minor updates
[distro-setup] / btrbk-run
index c59faf99c9eecb0e976a532bd6e2ef00225c59f7..759b3a4782ae32407c86e5a5e5ba745a589d10f4 100755 (executable)
--- a/btrbk-run
+++ b/btrbk-run
@@ -1,17 +1,29 @@
 #!/bin/bash
+# Copyright (C) 2016 Ian Kelling
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
-
 usage() {
     echo "top of script file:"
     sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
     exit $1
 }
 
-script_dir=$(dirname $(readlink "$BASH_SOURCE"))
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 
 # todo: finish figuring out fai / distro-setup
 # initial fstab / subvol setup.
@@ -20,14 +32,16 @@ conf_only=false
 dry_run=false # mostly for testing
 resume_arg=
 
-temp=$(getopt -l help hcnrt: "$@") || usage 1
+temp=$(getopt -l help hcnprt: "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
         -c) conf_only=true; shift ;;
         -n) dry_run=true; dry_run_arg=-n; shift ;;
+        -p) progress_arg="--progress"; shift ;;
+        # btrbk arg: Resume only. Skips snapshot creation.
         -r) resume_arg=-r; shift ;;
-        -t) IFS=, targets=($2); shift 2 ;;
+        -t) IFS=, targets=($2); unset IFS; shift 2 ;;
         -h|--help) usage ;;
         --) shift; break ;;
         *) echo "$0: Internal error!" ; exit 1 ;;
@@ -37,30 +51,73 @@ read primary <<<"$@"
 
 ##### end command line parsing ########
 
-target-section() {
-    local root=$1
-    local subvol=$2
-    mountpoint $root &>/dev/null || return
-    cat >>/etc/btrbk.conf <<EOF
-volume $root
-subvolume $subvol
-$remote_target
-
-EOF
-}
-
 rsync-dirs() {
     local host=$1
     local path=$2
-    rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+    m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+}
+
+vol-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+volume $vol
+EOF
+}
+sub-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+subvolume $sub
+EOF
 }
+tg-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+target send-receive ssh://$tg$vol/btrbk
+EOF
+}
+m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
+
 
+if ! which btrbk &>/dev/null; then
+    echo "$0: error: no btrbk binary found"
+fi
+
+cat >/etc/btrbk.conf <<'EOF'
+ssh_identity /root/.ssh/id_rsa
+# Just a guess that local7 is a good facility to pick.
+# It's a bit odd that the transaction log has to be logged to
+# a file or syslog, while other output is sent to std out.
+# The man does not mention a way for them to be together, but
+# I dunno if setting a log level like warn might also output
+# transaction info.
+transaction_syslog local7
+
+# so we only run one at a time
+lockfile                   /var/lock/btrbk.lock
+
+# default format of short does not accomidate hourly preservation setting
+timestamp_format long-iso
+
+# only make a snapshot if things have changed
+snapshot_create onchange
+# I could make this different from target_preserve,
+# if one disk had less space.
+# for now, keeping them equal.
+snapshot_preserve 36h 14d 8w 24m
+snapshot_preserve_min 4h
+snapshot_dir btrbk
+
+# so, total backups = ~89
+target_preserve 36h 14d 8w 24m
+target_preserve_min 4h
+
+# if something fails and it's not obvious, try doing
+# btrbk -l debug -v dryrun
+EOF
 
 # note q is owned by root:1000
 # note p is owned 1000:1000 and chmod 700
-mountpoints=(/q)
-if awk '{print $2}' /etc/fstab | grep -xF /p &>/dev/null; then
-    mountpoints+=(/p)
+mountpoints=(/a)
+qmnt=/q
+if awk '{print $2}' /etc/fstab | grep -xF $qmnt &>/dev/null; then
+    mountpoints+=($qmnt)
 fi
 
 # if our mountpoints are from stale snapshots,
@@ -74,68 +131,72 @@ if [[ ! $targets ]]; then
                 targets=($HOME_DOMAIN)
             fi
             ;;
+        treetowl)
+            targets=(frodo)
+            if timeout -s 9 10 ssh x2 :; then
+                targets+=(x2)
+            fi
+            ;;
+        *)
+            targets=(frodo)
+            ;;
     esac
-    targets=(frodo)
+    echo "targets: ${targets[*]}"
 fi
 
 
-# todo: make bash shell prompt show something when
-# a subvol on current host is not fresh.
-# umount first to ensure we don't have any errors
-# todo: do some kill fuser stuff to make umount more reliable
-# todo: run this on a systemd timer on $primary, once per hour,
-# and if primary is, change that timer over to primary, and make
-# sure we mount the latest
-# todo: setup lock so that if this is already running, we exit out, so
-# that manual runs don't interfere with cronjobs.
-
+# for i, we just do a 1 way sync from master to backup,
+# and manually manage any changes to that.
+do_i=false
 for tg in ${targets[@]}; do
-    cat >/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
-transaction_syslog daemon
+    # for an initial run, btrbk requires the dir to exist
+    ssh root@$tg mkdir -p /mnt/root/btrbk
+    if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
+        do_i=true
+    fi
+done
 
-# so we only run one at a time
-lockfile                   /var/lock/btrbk.lock
 
-# default format of short does not accomidate hourly preservation setting
-timestamp_format long-iso
+vol=/mnt/root
+vol-conf
+for m in ${mountpoints[@]}; do
+    sub=${m##*/}
+    sub-conf
+    for tg in ${targets[@]}; do
+        tg-conf
+    done
+done
 
-# only make a snapshot if things have changed
-snapshot_create onchange
-# much less snapshots because I have less space on the
-# local filesystem.
-#snapshot_preserve 2h 2d
-# for now, keeping them equal for simplicity sake
-snapshot_preserve 48h 14d 8w 24m
-snapshot_preserve_min 6h
-snapshot_dir btrbk
+if $do_i; then
+    vol=/mnt/iroot
+    vol-conf
+    sub=i
+    sub-conf
+    tg=frodo
+    vol=/mnt/root
+    tg-conf
+fi
 
-# so, total backups = ~89
-target_preserve 48h 14d 8w 24m
-target_preserve_min 6h
 
-# if something fails and it's not obvious, try doing
-# btrbk -l debug -v dryrun
-EOF
 
-    remote_target="target send-receive ssh://${tg}/mnt/root/btrbk"
+# todo: umount first to ensure we don't have any errors
+# todo: do some kill fuser stuff to make umount more reliable
+# todo: run this on a systemd timer on $primary, once per hour,
+# and if primary is, change that timer over to primary, and make
+# sure we mount the latest
+
 
-    if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-        target-section /mnt/iroot i
-    fi
-    for d in ${mountpoints[@]}; do
-        target-section /mnt/root ${d##*/}
-    done
-done
 
 if $conf_only; then
     exit
 fi
 
 if $dry_run; then
-    btrbk -n $resume_arg run
+    btrbk -n $resume_arg run
 else
-    btrbk -q $resume_arg run
+    # -q and just using the syslog option seemed nice,
+    # but it doesn't show when a send has a parent and when it doesn't.
+    m btrbk $progress_arg $resume_arg run
 fi
 
 # if we have /p, rsync to targets without /p
@@ -155,15 +216,7 @@ if mountpoint /p >/dev/null; then
 fi
 
 if ! $dry_run; then
-    for tg in ${targets[@]}; do
-        scp $script_dir/{mount-latest-subvol,check-subvol-stale} \
-            root@$tg:/usr/local/bin
-        ssh root@$tg bash <<'EOF'
-set -e
-chmod +x /usr/local/bin/{mount-latest-subvol,check-subvol-stale}
-mount-latest-subvol
-EOF
-    done
+    m $script_dir/mount-latest-remote ${targets[@]}
 fi